﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Roslyn.Compilers;
using Roslyn.Scripting.CSharp;
using Roslyn.Scripting;


namespace ConsoleApplication1
{
    public class Program
    {
        public delegate void TimeChangedDelegate(object objState);
        public TimeChangedDelegate TimeChanged;

        static void Main(string[] args)
        {
            Program pg = new Program();
            pg.TestIt();
        }

        private void TestIt()
        {
            var engine = new ScriptEngine(new[]
                                            {
                                                "System",
                                             this.GetType().Assembly.Location
                                            }); 

            var session = Session.Create(this);
            engine.Execute("using System;", session);
            engine.Execute("Console.WriteLine(DateTime.Now);", session);
            engine.Execute("DoHostCode();", session);
            engine.Execute("void timeChanged(object state) { Console.WriteLine(state); }", session);
            engine.Execute("TimeChanged += new TimeChangedDelegate(timeChanged);", session);

//            engine.Execute("int _value = unchecked((int)5);", session);

            Console.WriteLine(TimeChanged != null);
            TimeChanged(DateTime.Now);
        }

        public void DoHostCode()
        {
            Console.WriteLine("Program.DoHostCode called!");
        }
    }
}
